// Guidedtour.cc

Class OneClickWeb of CGISession from ":dQuery:dqWebClass.cc"

   this.ParentQuery = ""
   this.ChildQuery  = ""
   this.LinkField   = ""

   ////////////////////////////////////////////////////
   ///
   /// Override method from parent because of a bug that
   /// prevents editing a record.  
   ///
   ////////////////////////////////////////////////////
   Function loadDataModuleFromArray(oDataMod,bAppend)
  
      if empty(oDataMod)
         return false // no datamodule to work with
      endif

      oD = oDataMod  // "Privatize param"  for use in macros

      // ensure default of bAppand
      
      // There is a bug in dQWebClass.cc.  In the next line, if 
      // bAppend is false (i.e. edit mode), it always returns true 
      // and so you find yourself in the append mode rather than 
      // in the expected edit mode at the end.
      
      // bAppend = iif(empty(bAppend),true,bAppend)
      
      // Marko Mihorko's fix for this bug is:
      bAppend = iif(argcount()=1,true,bAppend)


      ////// This array will track which queries have already
      ////// been appended so we don't create extra rows  or
      ////// save rows unneccessarily

      aAppends = new array()

      ////// Traverse this array of field/value pairs and update
      ////// rowset fields with data

      cKey = this.firstKey  // init first key 

         
      For n = 1 to this.Count()  // traverse entire array

         if at('*@',cKey) = 0    // if not a datamod pair
            cKey = this.nextKey(cKey)
            loop                 // do next one
         endif
  
         ////// extract query name
         cQuery = substr(cKey,1,at("*@",cKey)-1)

     
         ////// Prepare macro to test query
         cStr = 'oD.'+cQuery
           
         ////// See if query exists
         Try
            oQuery = &cStr.
         catch (exception e)
            // this query does not exist!
         
            cKey = this.nextKey(cKey)
            loop
         endTry


         if type('oQuery.rowset') # 'O'
            // Rowset not valid???
            cKey = this.nextKey(cKey)
            loop
         endif

         ////// See if this query has been appended or edited
         ////// if not, append row if bAppend = true
         if aAppends.scan(upper(cQuery))  = 0

            aAppends.add(upper(cQuery)) // add to query array
            if bAppend      
               oQuery.rowset.beginAppend()
            else
               oQuery.rowset.beginEdit()
            endif

         endif

         ////// extract field name
         cField = trim(substr(cKey,at("*@",cKey)+2))

         if type('oQuery.rowset.fields[cField]') # 'O' // if no such field exists

            // loop and try the next
            cKey = this.nextKey(cKey)
            loop
         endif


         with (oQuery.rowset.fields[cField])       // with (field) 

            ////// Convert from string to type and update field value    
       
            if type 	= "LOGICAL"

               value  = ;
                  iif(upper(this[cKey]) = 'TRUE' or upper(this[cKey]) = 'Y',;
                  true,false)

            elseif type = "NUMERIC" or ;
               type = "INTEGER" or ;
               type = "LONG" or ;
               type = "DOUBLE" or ;
               type = "FLOAT"

               value = val(this[cKey])

            elseif type = "DATE"

               value = ctod(this[cKey])

            elseif type = 'AUTOINC' or ;
                   type = 'TIMESTAMP'  or ;
                   type = 'BINARY' or ;
                   type = 'OLE'

               	// do nothing, not supported in HTML


            else 	// char or memo   

               value = this[cKey]
                 
            endif

         endwith

         cKey = this.nextKey(cKey)
             
      Next

      ////// Traverse all queries and save rows
      for n = 1 to alen(aAppends,1) 
         cQuery = aAppends[n]

         cStr = 'oD.'+cQuery  // Prepare string for macro

         try
            oQuery = &cStr.   // Get reference for this query
         catch (exception e)
            loop              // if fail, go to next
         endTry


         if not oQuery.rowset.endOfSet
            oQuery.rowset.modified = true
            oQuery.rowset.save() // save row.
         endif

      next


   //////////////////////////////////////
   /// Override of streamResponsePage.
   /// We will add a link so that a
   /// child record can be added after
   /// a parent is added.
   //////////////////////////////////////

   function streamResponsePage(cBack,cBar,cLogo)

      with (this.fOut)
         puts('Content-type: text/html')
         puts('')
 
         puts('<html>')
         puts('<head>')
         puts('<title>dQuery/Web</title>')
         puts('<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">')
         puts('</head>')
         puts('<body bgcolor="'+cBack+'" link="#000000" vlink="#000000" alink="#000000">')
         puts('<table width="74%" border="0" cellpadding="2">')
         puts('  <tr> ')
         puts('    <td rowspan="2"><img src="/dqWebLogo.GIF" width="100" height="52"></td>')
         puts('    <td width="92%">')
         puts('      <table width="100%" border="0" cellpadding="2">')
         puts('        <tr> ')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td bgcolor="'+cBar+'">&nbsp;</td>')
         puts('          <td>&nbsp;</td>')
         puts('        </tr>')
         puts('      </table>')
         puts('    </td>')
         puts('  </tr>')
         puts('  <tr> ')
         puts('    <td width="92%">&nbsp;</td>')
         puts('  </tr>')
         puts('</table>')
         puts('<table width="74%" border="0" cellpadding="2" height="116">')
         puts('  <tr> ')
         puts('    <td width="4%" height="52">&nbsp;</td>')
         puts('    <td width="4%" bgcolor="'+cBar+'" height="52">&nbsp;</td>')
         puts('    <td width="92%" align="center" height="52"> ')
         puts('      <blockquote>')
         puts('        <h2 align="left"><font color="#999999">Data Entered Successfully!</font></h2>')
         puts('      </blockquote>')
         puts('    </td>')
         puts('  </tr>')
         puts('  <tr> ')
         puts('    <td width="4%" height="46">&nbsp;</td>')
         puts('    <td width="4%" bgcolor="'+cBar+'" height="46">&nbsp;</td>')
         puts('    <td width="92%" align="center" height="46"> ')
         puts('      <blockquote> ')
         puts([        <p align="left"><font face="Arial, Helvetica, sans-serif">Press the Browser's ])
         puts('          Back button to<br>')
         puts('          add another entry. </font><font face="Arial, Helvetica, sans-serif">Click ')
         puts('          &quot;Reset&quot; to clear out the form...</font></p>')
      endwith

if this.ParentQuery $ this['cmd']

   cScriptName = getenv("SCRIPT_NAME")   
   cFieldString = "dMod." + this.ParentQuery + ".rowset.fields['" + this.linkField + "'].value"
   cLinkID =  ltrim(str(&cFieldString))
   this.fOut.puts('<p align="left"><font face="Arial, Helvetica, sans-serif">')
   this.fOut.puts([<A href=']+cScriptName+[?cmd=ADD] + this.ChildQuery + [&] + this.linkField+ [=]+cLinkID+['>Enter Invoices for this customer now.</A>])
   this.fOut.puts('</font></p>')

endif

      with(this.fOut)
         puts('      </blockquote>')
         puts('    </td>')
         puts('  </tr>')
         puts('  <tr> ')
         puts('    <td width="4%" height="25">&nbsp;</td>')
         puts('    <td width="4%" bgcolor="'+cBar+'" height="25">&nbsp;</td>')
         puts('    <td width="92%" align="center" height="25">&nbsp;</td>')
         puts('  </tr>')
         puts('</table>')
         puts('</body>')
         puts(' ')
         puts('   </BODY>')
         puts(' ')
         puts('</HTML>')

	   endwith

      this.fOut.close()

      return true

/////////////////////////////////////////////////////////////////////////////////
/*  
    Method:  DisplayHTML()
    Params:  (rowsetFields, cPageName)
    Purpose: read an html-formated file and return the page to the web browser.            
    Authors: Michael Nuwer, a dBASE user 
             Ed Hoskins from dBASE Inc.
             (06/28/2000)
*/
/////////////////////////////////////////////////////////////////////////////////

Function DisplayHTML(rowsetFields,cHTMLFile,cPageTitle)
   // To display an HTML file with no database fields, 
   // send rowsetFields as null
   rFields = rowsetFields
   if empty(cHTMLFile)
     this.SorryPage("No HTML document was requested",;
                    "Missing Document",;
                    "Please contact the web master") 
   else if not file(cHTMLFile)
     this.SorryPage("No HTML document found",;
                    cHTMLFile,;
                    "Please contact the web master")
   else

     with (this.fOut)
         puts('Content-type: text/html')
         puts('')
      endwith
      this.fOut.Puts("")
      oHTML = new file()
      oHTML.open(cHTMLFile)
      do while not oHTML.eof()
         cLine = oHTML.Gets()
         //if rFields <> null   // removed 2/2001
            if at("<#",cLine) > 0
              nPos = 1
              do while nPos <= len(cLine)
                if substr(cLine,nPos,2) = "<#"
                  // we're at the start of a code
                  StartPos = nPos
                  nPos = nPos + 2
                  cName = ""
                  do while substr(cLine,nPos,1) <> ">"
                    cName = cName + substr(cLine,nPos,1)
                    nPos = nPos + 1
                  enddo
                  EndPos = nPos
                  cValue = ""
                  if rFields <> null and type("rFields[cName]") = "O"   // modified 2/2001 (see above)
                    with rFields[cName]
                      do case
                        case type="LOGICAL"
                          // Assume checkbox object
                          // You can also return html strings that
                          // refer to an image of a box for false
                          // and an image of a checkmark for true
                          cValue = iif(value,"Yes","No")
                        case type $ "BINARY,OLE"
                          // do nothing
                          // Add any special cases based on the type
                          // of tables you are using
                        otherwise
                          // generic auto-conversion
                          cValue = ""+value
                      endcase
                    endwith
                  else
                     // if the value is not a field in the table
                     // it should be in the CGI array as a value
                     // passed from the referring page
                     
                     if this.iskey(cName)
                        cValue = this[cName]
                     else
		        cValue = ""    // added 12/2001 to deal with 
			               // blanking <#Field> for add forms.
		     endif
                  endif
                  cLine = Stuff(cLine,StartPos,EndPos-StartPos+1,;
                          trim(""+cValue))
                  nPos = StartPos+len(trim(""+cValue))
                else
                  nPos = nPos + 1
                endif
              enddo
            endif
         //endif
         this.fOut.Puts(cLine)
      enddo
      oHTML.close()
      oHTML = null
   endif
return

endclass